From ed91a17e502d6df8e22e247948dca06cb9c3d753 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Laur=C3=A9line=20Gu=C3=A9rin?= <zebuline@entrouvert.com>
Date: Tue, 25 Oct 2022 18:47:48 +0200
Subject: [PATCH] manager: weekly wiew for agendas & resources (#33404)

---
 .../agendas/migrations/0090_default_view.py   |   7 +-
 chrono/agendas/models.py                      |   1 +
 chrono/manager/static/js/chrono.manager.js    |   4 +-
 .../chrono/manager_agenda_week_view.html      |  32 +
 .../manager_events_agenda_day_view.html       |   1 +
 .../manager_events_agenda_month_view.html     |   1 +
 .../manager_events_agenda_week_view.html      |  44 +
 .../manager_meetings_agenda_day_view.html     |   1 +
 .../manager_meetings_agenda_month_view.html   |  58 +-
 ...etings_agenda_week_timetable_fragment.html |  59 ++
 .../manager_meetings_agenda_week_view.html    |  12 +
 .../chrono/manager_resource_day_view.html     |   1 +
 .../chrono/manager_resource_detail.html       |   2 +
 .../chrono/manager_resource_month_view.html   |  44 +-
 ...ager_resource_week_timetable_fragment.html |  43 +
 .../chrono/manager_resource_week_view.html    |  32 +
 chrono/manager/urls.py                        |  15 +
 chrono/manager/views.py                       | 301 ++++--
 tests/manager/test_all.py                     | 860 ++++++++++++++++--
 tests/manager/test_resource.py                | 292 +++++-
 20 files changed, 1530 insertions(+), 280 deletions(-)
 create mode 100644 chrono/manager/templates/chrono/manager_agenda_week_view.html
 create mode 100644 chrono/manager/templates/chrono/manager_events_agenda_week_view.html
 create mode 100644 chrono/manager/templates/chrono/manager_meetings_agenda_week_timetable_fragment.html
 create mode 100644 chrono/manager/templates/chrono/manager_meetings_agenda_week_view.html
 create mode 100644 chrono/manager/templates/chrono/manager_resource_week_timetable_fragment.html
 create mode 100644 chrono/manager/templates/chrono/manager_resource_week_view.html

diff --git a/chrono/agendas/migrations/0090_default_view.py b/chrono/agendas/migrations/0090_default_view.py
index 6e65e3f9..a134ed65 100644
--- a/chrono/agendas/migrations/0090_default_view.py
+++ b/chrono/agendas/migrations/0090_default_view.py
@@ -12,7 +12,12 @@ class Migration(migrations.Migration):
             model_name='agenda',
             name='default_view',
             field=models.CharField(
-                choices=[('day', 'Day view'), ('month', 'Month view'), ('open_events', 'Open events')],
+                choices=[
+                    ('day', 'Day view'),
+                    ('week', 'Week view'),
+                    ('month', 'Month view'),
+                    ('open_events', 'Open events'),
+                ],
                 max_length=20,
                 verbose_name='Default view',
             ),
diff --git a/chrono/agendas/models.py b/chrono/agendas/models.py
index 2ece19a3..02606c58 100644
--- a/chrono/agendas/models.py
+++ b/chrono/agendas/models.py
@@ -70,6 +70,7 @@ AGENDA_KINDS = (
 
 AGENDA_VIEWS = (
     ('day', _('Day view')),
+    ('week', _('Week view')),
     ('month', _('Month view')),
     ('open_events', _('Open events')),
 )
diff --git a/chrono/manager/static/js/chrono.manager.js b/chrono/manager/static/js/chrono.manager.js
index 97d87a18..5b324886 100644
--- a/chrono/manager/static/js/chrono.manager.js
+++ b/chrono/manager/static/js/chrono.manager.js
@@ -10,8 +10,10 @@ $(function() {
     $('.date-picker button').on('click', function() {
     if ($('[name=day]').val()) {
        window.location = '../../../' + $('[name=year]').val() + '/' + $('[name=month]').val() + '/' + $('[name=day]').val() + '/';
-    } else {
+    } else if ($('[name=month]').val()) {
         window.location = '../../' + $('[name=year]').val() + '/' + $('[name=month]').val() + '/';
+    } else {
+        window.location = '../../../' + $('[name=year]').val() + '/week/' + $('[name=week]').val() + '/';
     }
     return false;
   });
diff --git a/chrono/manager/urls.py b/chrono/manager/urls.py
index cf1b924c..0d578414 100644
--- a/chrono/manager/urls.py
+++ b/chrono/manager/urls.py
@@ -73,6 +73,11 @@ urlpatterns = [
         views.resource_monthly_view,
         name='chrono-manager-resource-month-view',
     ),
+    re_path(
+        r'^resource/(?P<pk>\d+)/(?P<year>[0-9]{4})/week/(?P<week>[0-9]+)/$',
+        views.resource_weekly_view,
+        name='chrono-manager-resource-week-view',
+    ),
     re_path(
         r'^resource/(?P<pk>\d+)/(?P<year>[0-9]{4})/(?P<month>[0-9]+)/(?P<day>[0-9]+)/$',
         views.resource_day_view,
@@ -107,6 +112,16 @@ urlpatterns = [
         views.agenda_monthly_view,
         name='chrono-manager-agenda-month-view',
     ),
+    path(
+        'agendas/<int:pk>/week/',
+        views.agenda_week_redirect_view,
+        name='chrono-manager-agenda-week-redirect-view',
+    ),
+    re_path(
+        r'^agendas/(?P<pk>\d+)/(?P<year>[0-9]{4})/week/(?P<week>[0-9]+)/$',
+        views.agenda_weekly_view,
+        name='chrono-manager-agenda-week-view',
+    ),
     path(
         'agendas/<int:pk>/day/',
         views.agenda_day_redirect_view,
diff --git a/chrono/manager/views.py b/chrono/manager/views.py
index e9b12aed..23bcef9d 100644
--- a/chrono/manager/views.py
+++ b/chrono/manager/views.py
@@ -57,6 +57,7 @@ from django.views.generic import (
     TemplateView,
     UpdateView,
     View,
+    WeekArchiveView,
 )
 from django.views.generic.dates import MonthMixin, YearMixin
 from weasyprint import HTML
@@ -250,6 +251,9 @@ class DateMixin:
     def get_months(self):
         return [(str(x), MONTHS[x]) for x in range(1, 13)]
 
+    def get_weeks(self):
+        return [(str(x), _('Week %s') % x) for x in range(1, 53)]
+
     def get_years(self):
         year = now().year
         return [str(x) for x in range(year - 1, year + 5)]
@@ -384,28 +388,7 @@ class ResourceDayView(DateMixin, DayArchiveView):
 resource_day_view = ResourceDayView.as_view()
 
 
-class ResourceMonthView(DateMixin, MonthArchiveView):
-    template_name = 'chrono/manager_resource_month_view.html'
-    model = Event
-    month_format = '%m'
-    date_field = 'start_datetime'
-    allow_empty = True
-    allow_future = True
-
-    def dispatch(self, request, *args, **kwargs):
-        self.resource = get_object_or_404(Resource, pk=kwargs['pk'])
-        if not self.resource.can_be_viewed(request.user):
-            raise PermissionDenied()
-        try:
-            self.date = make_aware(
-                datetime.datetime.strptime(
-                    '%s-%s-%s 06:00' % (self.get_year(), self.get_month(), 1), '%Y-%m-%d %H:%M'
-                )
-            )
-        except ValueError:
-            raise Http404
-        return super().dispatch(request, *args, **kwargs)
-
+class ResourceWeekMonthMixin:
     def get_queryset(self):
         queryset = (
             self.resource.event_set.all()
@@ -418,22 +401,18 @@ class ResourceMonthView(DateMixin, MonthArchiveView):
         context = super().get_context_data(**kwargs)
 
         context['resource'] = self.resource
-
-        return context
-
-    def get_previous_month_url(self):
-        previous_month = self.get_previous_month(self.date.date())
-        return reverse(
-            'chrono-manager-resource-month-view',
-            kwargs={'pk': self.resource.pk, 'year': previous_month.year, 'month': previous_month.month},
+        context['kind'] = self.kind
+        context['hour_span'] = 1
+        durations = MeetingType.objects.filter(agenda__resources=self.resource).values_list(
+            'duration', flat=True
         )
+        if durations:
+            gcd = durations[0]
+            for duration in durations[1:]:
+                gcd = math.gcd(duration, gcd)
+            context['hour_span'] = max(60 // gcd, 1)
 
-    def get_next_month_url(self):
-        next_month = self.get_next_month(self.date.date())
-        return reverse(
-            'chrono-manager-resource-month-view',
-            kwargs={'pk': self.resource.pk, 'year': next_month.year, 'month': next_month.month},
-        )
+        return context
 
     def get_timetable_infos(self):
         interval = datetime.timedelta(minutes=60)
@@ -469,18 +448,20 @@ class ResourceMonthView(DateMixin, MonthArchiveView):
         hide_weekend = hide_weekend_timeperiod and hide_weekend_event
 
         # avoid displaying empty first week
-        first_week_offset = int(
-            (hide_sunday and self.date.weekday() == 6) or (hide_weekend and self.date.weekday() == 5)
-        )
-
+        first_week_offset = 0
         first_week_number = self.date.isocalendar()[1]
-        if first_week_number >= 52:
-            first_week_number = 0
-        last_month_day = self.get_next_month(self.date.date()) - datetime.timedelta(days=1)
-        last_week_number = last_month_day.isocalendar()[1]
+        last_week_number = first_week_number
+        if self.kind == 'month':
+            first_week_offset = int(
+                (hide_sunday and self.date.weekday() == 6) or (hide_weekend and self.date.weekday() == 5)
+            )
+            if first_week_number >= 52:
+                first_week_number = 0
+            last_day = self.get_next(self.date.date()) - datetime.timedelta(days=1)
+            last_week_number = last_day.isocalendar()[1]
 
-        if last_week_number < first_week_number:  # new year
-            last_week_number = 53
+            if last_week_number < first_week_number:  # new year
+                last_week_number = 53
 
         for week_number in range(first_week_number + first_week_offset, last_week_number + 1):
             yield self.get_week_timetable_infos(
@@ -528,8 +509,8 @@ class ResourceMonthView(DateMixin, MonthArchiveView):
             # until the end of the last hour.
             max_date += datetime.timedelta(hours=1)
 
-        # compute booking and opening hours only for current month
-        if self.date.month != day.month:
+        # compute booking and opening hours only for current month/week
+        if self.kind == 'month' and timetable['other_month']:
             return timetable
 
         while period <= max_date:
@@ -552,6 +533,92 @@ class ResourceMonthView(DateMixin, MonthArchiveView):
         return timetable
 
 
+class ResourceWeekView(ResourceWeekMonthMixin, DateMixin, WeekArchiveView):
+    template_name = 'chrono/manager_resource_week_view.html'
+    model = Event
+    week_format = '%W'
+    date_field = 'start_datetime'
+    allow_empty = True
+    allow_future = True
+    kind = 'week'
+
+    def dispatch(self, request, *args, **kwargs):
+        self.resource = get_object_or_404(Resource, pk=kwargs['pk'])
+        if not self.resource.can_be_viewed(request.user):
+            raise PermissionDenied()
+        try:
+            date = datetime.datetime.strptime('%s-W%s-1' % (self.get_year(), self.get_week()), "%Y-W%W-%w")
+            self.date = make_aware(
+                datetime.datetime.strptime(
+                    '%s-%s-%s 06:00' % (self.get_year(), date.month, date.day), '%Y-%m-%d %H:%M'
+                )
+            )
+        except ValueError:
+            raise Http404
+        return super().dispatch(request, *args, **kwargs)
+
+    def get_previous_week_url(self):
+        previous_week = self.get_previous_week(self.date.date())
+        return reverse(
+            'chrono-manager-resource-week-view',
+            kwargs={'pk': self.resource.pk, 'year': previous_week.year, 'week': previous_week.strftime('%W')},
+        )
+
+    def get_next_week_url(self):
+        next_week = self.get_next_week(self.date.date())
+        return reverse(
+            'chrono-manager-resource-week-view',
+            kwargs={'pk': self.resource.pk, 'year': next_week.year, 'week': next_week.strftime('%W')},
+        )
+
+    def get_next(self, date):
+        return self.get_next_week(date)
+
+
+resource_weekly_view = ResourceWeekView.as_view()
+
+
+class ResourceMonthView(ResourceWeekMonthMixin, DateMixin, MonthArchiveView):
+    template_name = 'chrono/manager_resource_month_view.html'
+    model = Event
+    month_format = '%m'
+    date_field = 'start_datetime'
+    allow_empty = True
+    allow_future = True
+    kind = 'month'
+
+    def dispatch(self, request, *args, **kwargs):
+        self.resource = get_object_or_404(Resource, pk=kwargs['pk'])
+        if not self.resource.can_be_viewed(request.user):
+            raise PermissionDenied()
+        try:
+            self.date = make_aware(
+                datetime.datetime.strptime(
+                    '%s-%s-%s 06:00' % (self.get_year(), self.get_month(), 1), '%Y-%m-%d %H:%M'
+                )
+            )
+        except ValueError:
+            raise Http404
+        return super().dispatch(request, *args, **kwargs)
+
+    def get_previous_month_url(self):
+        previous_month = self.get_previous_month(self.date.date())
+        return reverse(
+            'chrono-manager-resource-month-view',
+            kwargs={'pk': self.resource.pk, 'year': previous_month.year, 'month': previous_month.month},
+        )
+
+    def get_next_month_url(self):
+        next_month = self.get_next_month(self.date.date())
+        return reverse(
+            'chrono-manager-resource-month-view',
+            kwargs={'pk': self.resource.pk, 'year': next_month.year, 'month': next_month.month},
+        )
+
+    def get_next(self, date):
+        return self.get_next_month(date)
+
+
 resource_monthly_view = ResourceMonthView.as_view()
 
 
@@ -1082,6 +1149,9 @@ class AgendaView(ViewableAgendaMixin, View):
         if self.agenda.default_view == 'day':
             return redirect('chrono-manager-agenda-day-redirect-view', pk=self.agenda.pk)
 
+        if self.agenda.default_view == 'week':
+            return redirect('chrono-manager-agenda-week-redirect-view', pk=self.agenda.pk)
+
         if self.agenda.default_view == 'month':
             return redirect('chrono-manager-agenda-month-redirect-view', pk=self.agenda.pk)
 
@@ -1114,6 +1184,17 @@ class AgendaMonthRedirectView(ViewableAgendaMixin, View):
 agenda_month_redirect_view = AgendaMonthRedirectView.as_view()
 
 
+class AgendaWeekRedirectView(AgendaMonthRedirectView):
+    def get(self, request, *args, **kwargs):
+        day = self.get_day()
+        return redirect(
+            'chrono-manager-agenda-week-view', pk=self.agenda.pk, year=day.year, week=day.strftime('%W')
+        )
+
+
+agenda_week_redirect_view = AgendaWeekRedirectView.as_view()
+
+
 class AgendaDayRedirectView(AgendaMonthRedirectView):
     def get(self, request, *args, **kwargs):
         day = self.get_day()
@@ -1128,6 +1209,7 @@ agenda_day_redirect_view = AgendaDayRedirectView.as_view()
 class AgendaDateView(DateMixin, ViewableAgendaMixin):
     model = Event
     month_format = '%m'
+    week_format = '%W'
     date_field = 'start_datetime'
     allow_empty = True
     allow_future = True
@@ -1333,7 +1415,7 @@ class AgendaDayView(AgendaDateView, DayArchiveView):
 agenda_day_view = AgendaDayView.as_view()
 
 
-class AgendaMonthView(AgendaDateView, MonthArchiveView):
+class AgendaWeekMonthMixin:
     def get_queryset(self):
         qs = super().get_queryset()
         if self.agenda.kind != 'events':
@@ -1343,9 +1425,9 @@ class AgendaMonthView(AgendaDateView, MonthArchiveView):
     def get_dated_items(self):
         date_list, object_list, extra_context = super().get_dated_items()
         if self.agenda.kind == 'events':
-            min_start = make_aware(datetime.datetime.combine(extra_context['month'], datetime.time(0, 0)))
+            min_start = make_aware(datetime.datetime.combine(extra_context[self.kind], datetime.time(0, 0)))
             max_start = make_aware(
-                datetime.datetime.combine(extra_context['next_month'], datetime.time(0, 0))
+                datetime.datetime.combine(extra_context['next_%s' % self.kind], datetime.time(0, 0))
             )
             exceptions = TimePeriodException.objects.filter(
                 desk__agenda=self.agenda, start_datetime__gte=min_start, end_datetime__lt=max_start
@@ -1353,11 +1435,6 @@ class AgendaMonthView(AgendaDateView, MonthArchiveView):
             object_list = sorted(itertools.chain(object_list, exceptions), key=lambda x: x.start_datetime)
         return date_list, object_list, extra_context
 
-    def get_template_names(self):
-        if self.agenda.kind == 'virtual':
-            return ['chrono/manager_meetings_agenda_month_view.html']
-        return ['chrono/manager_%s_agenda_month_view.html' % self.agenda.kind]
-
     def get_context_data(self, **kwargs):
         context = super().get_context_data(**kwargs)
         if self.agenda.kind == 'events':
@@ -1367,25 +1444,9 @@ class AgendaMonthView(AgendaDateView, MonthArchiveView):
             ).all()
         else:
             context['single_desk'] = bool(len(self.agenda.prefetched_desks) == 1)
+        context['kind'] = self.kind
         return context
 
-    def get_previous_month_url(self):
-        previous_month = self.get_previous_month(self.date.date())
-        return reverse(
-            'chrono-manager-agenda-month-view',
-            kwargs={'pk': self.agenda.id, 'year': previous_month.year, 'month': previous_month.month},
-        )
-
-    def get_next_month_url(self):
-        next_month = self.get_next_month(self.date.date())
-        return reverse(
-            'chrono-manager-agenda-month-view',
-            kwargs={'pk': self.agenda.id, 'year': next_month.year, 'month': next_month.month},
-        )
-
-    def get_day(self):
-        return '1'
-
     def get_timetable_infos(self):
         timeperiods = itertools.chain(*(d.timeperiod_set.all() for d in self.agenda.prefetched_desks))
         timeperiods = sorted(timeperiods, key=lambda t: (t.weekday, t.start_time))
@@ -1419,18 +1480,21 @@ class AgendaMonthView(AgendaDateView, MonthArchiveView):
         hide_weekend = hide_weekend_timeperiod and hide_weekend_event
 
         # avoid displaying empty first week
-        first_week_offset = int(
-            (hide_sunday and self.date.weekday() == 6) or (hide_weekend and self.date.weekday() == 5)
-        )
-
+        first_week_offset = 0
         first_week_number = self.date.isocalendar()[1]
-        if first_week_number >= 52:
-            first_week_number = 0
-        last_month_day = self.get_next_month(self.date.date()) - datetime.timedelta(days=1)
-        last_week_number = last_month_day.isocalendar()[1]
+        last_week_number = first_week_number
+        if self.kind == 'month':
+            first_week_offset = int(
+                (hide_sunday and self.date.weekday() == 6) or (hide_weekend and self.date.weekday() == 5)
+            )
+            first_week_number = self.date.isocalendar()[1]
+            if first_week_number >= 52:
+                first_week_number = 0
+            last_day = self.get_next(self.date.date()) - datetime.timedelta(days=1)
+            last_week_number = last_day.isocalendar()[1]
 
-        if last_week_number < first_week_number:  # new year
-            last_week_number = 53
+            if last_week_number < first_week_number:  # new year
+                last_week_number = 53
 
         for week_number in range(first_week_number + first_week_offset, last_week_number + 1):
             yield self.get_week_timetable_infos(
@@ -1474,8 +1538,8 @@ class AgendaMonthView(AgendaDateView, MonthArchiveView):
         desks_len = len(desks)
         max_date = day.replace(hour=self.max_display.hour, minute=0)
 
-        # compute booking and opening hours only for current month
-        if self.date.month != day.month:
+        # compute booking and opening hours only for current month/week
+        if self.kind == 'month' and timetable['other_month']:
             return timetable
 
         while period <= max_date:
@@ -1536,6 +1600,73 @@ class AgendaMonthView(AgendaDateView, MonthArchiveView):
         return timetable
 
 
+class AgendaWeekView(AgendaWeekMonthMixin, AgendaDateView, WeekArchiveView):
+    week_format = "%W"
+    kind = 'week'
+
+    def get_template_names(self):
+        if self.agenda.kind == 'virtual':
+            return ['chrono/manager_meetings_agenda_week_view.html']
+        return ['chrono/manager_%s_agenda_week_view.html' % self.agenda.kind]
+
+    def get_previous_week_url(self):
+        previous_week = self.get_previous_week(self.date.date())
+        return reverse(
+            'chrono-manager-agenda-week-view',
+            kwargs={'pk': self.agenda.id, 'year': previous_week.year, 'week': previous_week.strftime('%W')},
+        )
+
+    def get_next_week_url(self):
+        next_week = self.get_next_week(self.date.date())
+        return reverse(
+            'chrono-manager-agenda-week-view',
+            kwargs={'pk': self.agenda.id, 'year': next_week.year, 'week': next_week.strftime('%W')},
+        )
+
+    def get_next(self, date):
+        return self.get_next_week(date)
+
+    def get_month(self):
+        date = datetime.datetime.strptime('%s-W%s-1' % (self.get_year(), self.get_week()), "%Y-W%W-%w")
+        return date.month
+
+    def get_day(self):
+        date = datetime.datetime.strptime('%s-W%s-1' % (self.get_year(), self.get_week()), "%Y-W%W-%w")
+        return date.day
+
+
+agenda_weekly_view = AgendaWeekView.as_view()
+
+
+class AgendaMonthView(AgendaWeekMonthMixin, AgendaDateView, MonthArchiveView):
+    kind = 'month'
+
+    def get_template_names(self):
+        if self.agenda.kind == 'virtual':
+            return ['chrono/manager_meetings_agenda_month_view.html']
+        return ['chrono/manager_%s_agenda_month_view.html' % self.agenda.kind]
+
+    def get_previous_month_url(self):
+        previous_month = self.get_previous_month(self.date.date())
+        return reverse(
+            'chrono-manager-agenda-month-view',
+            kwargs={'pk': self.agenda.id, 'year': previous_month.year, 'month': previous_month.month},
+        )
+
+    def get_next_month_url(self):
+        next_month = self.get_next_month(self.date.date())
+        return reverse(
+            'chrono-manager-agenda-month-view',
+            kwargs={'pk': self.agenda.id, 'year': next_month.year, 'month': next_month.month},
+        )
+
+    def get_next(self, date):
+        return self.get_next_month(date)
+
+    def get_day(self):
+        return '1'
+
+
 agenda_monthly_view = AgendaMonthView.as_view()
 
 
